// #include <xc.h>
#include "atmel_start.h"
#include "hal_delay.h"
#include "APP1632_LCM.h"

#define SystemFrequency			4000000L / 2

//#define IntLCM_Delay1ns			( SystemFrequency * 1 ) / 1000000000L / 10
//#define IntLCM_Delay10ns		( SystemFrequency * 10 ) / 1000000000L / 10
//#define IntLCM_Delay100ns		( SystemFrequency * 100 ) / 1000000000L / 10

/*

#define IntLCM_Delay1us                          ( SystemFrequency * 1 ) / 1000000L / 10
#define IntLCM_Delay10us                        ( SystemFrequency * 10 ) / 1000000L / 10
#define IntLCM_Delay100us                       ( SystemFrequency * 100 ) / 1000000L / 10

#define IntLCM_Delay1ms			( SystemFrequency * 1 ) / 1000L / 10
#define IntLCM_Delay10ms		( SystemFrequency * 10 ) / 1000L / 10
#define IntLCM_Delay100ms		( SystemFrequency * 100 ) / 1000L / 10

*/

/*

#define LCM_RS					LATGbits.LATG15 
#define LCM_RW					LATEbits.LATE6 
#define LCM_E					LATEbits.LATE3 

#define LCM_D4					LATCbits.LATC3 
#define LCM_D5					LATCbits.LATC4
#define LCM_D6					LATCbits.LATC1
#define LCM_D7					LATCbits.LATC2 

#define LCM_TRIS_RS				TRISGbits.TRISG15 
#define LCM_TRIS_RW				TRISEbits.TRISE6
#define LCM_TRIS_E				TRISEbits.TRISE3 

#define LCM_TRIS_D4				TRISCbits.TRISC3 
#define LCM_TRIS_D5				TRISCbits.TRISC4 
#define LCM_TRIS_D6				TRISCbits.TRISC1 
#define LCM_TRIS_D7				TRISCbits.TRISC2 

*/

// " / 10 " <- Fix C Code Function

void LCM_Delay( unsigned long Count )
{

	while( Count-- )
	{
		delay_us(10);
	}
}

void IntLCM_Communication( unsigned char NibbleByte )
{
	unsigned char Temporary;
	//Temporary = NibbleByte & 0x0f;

	LCM_Delay( 100 );			// Delay 1000 us

	gpio_set_pin_level(LCM_D7,false);
	gpio_set_pin_level(LCM_D6,false);
	gpio_set_pin_level(LCM_D5,false);
	gpio_set_pin_level(LCM_D4,false);


	Temporary = NibbleByte & 0x0f;
	if( ( Temporary & 0x08 ) == 0x08 )			// D7
		gpio_set_pin_level(LCM_D7,true);

	Temporary = NibbleByte & 0x0f;
	if( ( Temporary & 0x04 ) == 0x04 )			// D6
		gpio_set_pin_level(LCM_D6,true);

	Temporary = NibbleByte & 0x0f;
	if( ( Temporary & 0x02 ) == 0x02 )			// D5
		gpio_set_pin_level(LCM_D5,true);

	Temporary = NibbleByte & 0x0f;
	if( ( Temporary & 0x01 ) == 0x01 )			// D4
		gpio_set_pin_level(LCM_D4,true);

	gpio_set_pin_level(LCM_E,true);
	LCM_Delay( 5 );		         //PWEH
	
	gpio_set_pin_level(LCM_E,false);
	LCM_Delay( 5 );				//tAH
}

unsigned char LCM_IsBusy( void )
{

/*
	unsigned char Temporary;

	PMPSetAddress( LCM_INSTRUCTION );
	Temporary = mPMPMasterReadByte( );		// Dummy Read for trigger PMP active.

	while( !INTGetFlag( INT_PMP ) );		// Wait PMP Complete.
	INTClearFlag( INT_PMP );

	Temporary = mPMPMasterReadByte( );

	return ( ( Temporary >> 7 ) & 0x01 ); 
*/

	unsigned int i;

	for( i = 0 ; i < 1000 ; i++ );
	return 0;
}


void IntLCM_WriteData( unsigned char Data )
{
	while( LCM_IsBusy( ) );
	gpio_set_pin_level(LCM_RS,true);
	gpio_set_pin_level(LCM_RW,false);

	IntLCM_Communication( ( Data >> 4 ) & 0x0f );
	IntLCM_Communication( Data & 0x0f );
}

void IntLCM_WriteInstruction( unsigned char Instruction )
{
	while( LCM_IsBusy( ) );
	gpio_set_pin_level(LCM_RS,false);
	gpio_set_pin_level(LCM_RW,false);	

	IntLCM_Communication( ( Instruction >> 4 ) & 0x0f );
	IntLCM_Communication( Instruction & 0x0f );
}

void LCM_Init( void )
{
	// LCM_IOSetup( );

															// RS = 0 , Instruction
	gpio_set_pin_level(LCM_RS,false);
	gpio_set_pin_level(LCM_RW,false);

	IntLCM_Communication( 0x03 );							// Reset
	LCM_Delay( 500 );										// Wait 4.1 mSecs  500*10us = 5000us = 5ms

	IntLCM_Communication( 0x03 );							// Reset
	LCM_Delay( 20);											// Wait 100 uSecs	20 *10us = 200 us

	IntLCM_Communication( 0x03 );							// Reset
	LCM_Delay( 20 );										// Wait 100 uSecs

	IntLCM_Communication( 0x02 );
	LCM_Delay( 20 );										// Wait 100 uSecs

	IntLCM_Communication( ( 0x28 >> 4 ) & 0x0f );
	IntLCM_Communication( 0x28 & 0xf );
	LCM_Delay( 10 );

	IntLCM_Communication( ( Disp_Off >> 4 ) & 0x0f );		// Dsplay Off
	IntLCM_Communication( Disp_Off & 0xf );
	LCM_Delay( 10 );

	IntLCM_Communication( ( Disp_Clear >> 4 ) & 0x0f );		// Dsplay Clear
	IntLCM_Communication( Disp_Clear & 0xf );
	LCM_Delay( 200 );

	IntLCM_Communication( ( Disp_Entry_Inc >> 4 ) & 0x0f );	// Entry Mode
	IntLCM_Communication( Disp_Entry_Inc & 0xf );
	LCM_Delay( 10 );

	IntLCM_Communication( ( Disp_On >> 4 ) & 0x0f );		// Display On
	IntLCM_Communication( Disp_On & 0xf );
	LCM_Delay( 10 );
}

void LCM_SetCursor( unsigned char X, unsigned char Y )
{
	IntLCM_WriteInstruction( ( 0x80 + ( Y * 0x40 ) + X ) );
}

void LCM_PutASCII(unsigned char Ascii )
{
	IntLCM_WriteData( Ascii );
}

void LCM_PutHex(unsigned char Hex )
{
	unsigned char Temporary;

	Temporary = ( Hex >> 4 ) & 0x0f ;

	if ( Temporary > 9 ) 
		Temporary += 0x37;
    else
		Temporary += '0';

	IntLCM_WriteData( Temporary );

	Temporary = Hex & 0x0f;
	if ( Temporary > 9 )
		Temporary += 0x37;
    else Temporary += '0';
		IntLCM_WriteData( Temporary );
}

void LCM_PutROMString( const unsigned char *String )
{
	while ( *String != 0x00 )
		IntLCM_WriteData( *String++ );
}

void LCM_PutRAMString( unsigned char *String )
{
	while ( *String != 0x00 )
		IntLCM_WriteData( *String++ );
}

static unsigned char Disable_Zero = 1;

unsigned char LCM_BCD_Regulate( unsigned char BCD )
{
		if ( BCD == 0 ) 
		{
			if ( Disable_Zero == 1 ) 
				return ' ';
			else
				return '0';
		}

		else 
		{
			Disable_Zero = 0;
			return ( BCD += '0' );
		}		
}

void LCM_PutNumber( unsigned int Number , unsigned char Digit )
{
	unsigned char Temporary;
	Disable_Zero = 1;

	switch ( Digit )
	{
		default:
		case 4:
			Temporary = LCM_BCD_Regulate( ( Number % 10000 ) / 1000 );
			IntLCM_WriteData( Temporary );

		case 3:
			Temporary = LCM_BCD_Regulate( ( Number % 1000 ) / 100 );
			IntLCM_WriteData( Temporary );

		case 2:
			Temporary = LCM_BCD_Regulate( ( Number % 100 ) / 10 );
			IntLCM_WriteData( Temporary );

		case 1:
			Disable_Zero = 0;
			Temporary = LCM_BCD_Regulate( Number % 10 );
			IntLCM_WriteData( Temporary );
	}
}
